#!/bin/sh
################################
#####  Persian HD Project  #####
#######  Persian Prince  #######
##  https://persianpros.com  ###
################################

LINE="----------------------------------------------------------"
SWAPTMP=/tmp/.swaptmp
SWAPDIR=/media/hdd
if [ `mount | grep /media/usb | wc -l` -gt 0 ]; then
   SWAPDIR=/media/usb
fi
if [ `mount | grep /media/cf | wc -l` -gt 0 ]; then
   SWAPDIR=/media/cf
fi
SWAPSIZE=32768
if [ $# -gt 2 ]; then
   SWAPDIR=$3
fi
if [ $# -gt 1 ]; then
   if [ $2 -gt 8 ]; then
      SWAPSIZE=`expr $2 "*" 1024`
   else
      SWAPSIZE=8192
   fi
fi

case "$1" in
   "info" )
   echo $LINE
   free
   if [ `cat /proc/swaps | wc -l` -gt 0  ]; then
      echo $LINE
      echo "Swap Enabled"
      echo $LINE
      cat /proc/swaps
      echo $LINE
      exit 0
   else
      echo $LINE
      echo "Swap Disabled"
      echo $LINE
      exit 0
   fi
   ;;
   "start" | "enable" | "restart" )
   if [ `cat /proc/swaps | wc -l` -gt 0  ]; then
      echo $LINE
      echo "Swap Already Enabled"
      echo $LINE
      cat /proc/swaps
      echo $LINE
      exit 0
   fi
   if [ ! -d $SWAPDIR ]; then
      $ECHO "Swap Directory $SWAPDIR Doesn't Exist"
      $CR
      echo $LINE
      exit 1
   fi
   if [ `mount | grep $SWAPDIR | wc -l` -eq 0  ]; then
      $ECHO "Swap Directory $SWAPDIR Isn't Mounted"
      $CR
      echo $LINE
      exit 1
   fi
   echo $LINE
   free
   echo $LINE
   if [ -f $SWAPDIR/swapfile ]; then
      echo "Swap File $SWAPDIR/swapfile Already Exists"
      echo $LINE
   else
      echo "Creating Swap File $SWAPDIR/swapfile With $SWAPSIZE KB"
      echo $LINE
      dd if=/dev/zero of=$SWAPDIR/swapfile bs=1024 count=$SWAPSIZE
      echo $LINE
      mkswap $SWAPDIR/swapfile
      echo $LINE
   fi
   echo "Swap On $SWAPDIR"
   swapon -a
   echo $LINE
   free
   echo $LINE
   swapon $SWAPDIR/swapfile > /dev/null 2>&1
   echo "Adding Swap File To /etc/fstab"
   grep -v swap /etc/fstab > $SWAPTMP
   echo "$SWAPDIR/swapfile    none swap sw 0 0" >> $SWAPTMP
   cp $SWAPTMP /etc/fstab > /dev/null 2>&1
   echo $LINE
   echo "Swap File Enabled" 
   echo $LINE
   ;;
   "stop" | "disable")
   if [ `cat /proc/swaps | wc -l` -eq 0  ]; then
      echo $LINE
      echo "Swap Already Disabled"
      echo $LINE
      exit 0
   fi
   if [ ! -f "$SWAPDIR/swapfile" ]; then
      $ECHO "Swap File $SWAPDIR/swapfile Doesn't Exist"
      $CR
      echo $LINE
      exit 0
   fi
   echo $LINE
   free
   echo $LINE
   echo "Swap Off $SWAPDIR"
   swapoff $SWAPDIR/swapfile > /dev/null 2>&1
   rm $SWAPDIR/swapfile > /dev/null 2>&1
   grep -v swap /etc/fstab > $SWAPTMP
   cp $SWAPTMP /etc/fstab > /dev/null 2>&1
   echo $LINE
   free
   echo $LINE
   ;;
    *)
	echo "Usage:"
	echo "$0 start|stop|enable|disable size_in_MB /media/cf|/media/usb|/media/hdd"
	exit 1
	;;
esac

exit 0
