#!/bin/sh
################################
#####  Persian HD Project  #####
#######  Persian Prince  #######
##  https://persianpros.com  ###
################################

MYTMP0=/tmp/.mytmp0
MYTMP1=/tmp/.mytmp1
MYTMP2=/tmp/.mytmp2
HD_PATH=/dev/ide/host0/bus0/target0/lun0
HD1_PATH=/dev/ide/host0/bus0/target0/lun0
HD2_PATH=/dev/ide/host0/bus1/target0/lun0
if [ -e $HD2_PATH/part1 ]; then
   HD_PATH=$HD2_PATH
fi
if [ -e $HD1_PATH/part1 ]; then
   HD_PATH=$HD1_PATH
fi
USB_PATH=/dev/scsi/host0/bus0/target0/lun0
USB0_PATH=/dev/scsi/host0/bus0/target0/lun0
USB1_PATH=/dev/scsi/host1/bus0/target0/lun0
USB2_PATH=/dev/scsi/host2/bus0/target0/lun0
USB3_PATH=/dev/scsi/host3/bus0/target0/lun0
USB4_PATH=/dev/scsi/host4/bus0/target0/lun0
USB5_PATH=/dev/scsi/host0/bus0/target0/lun2
USB6_PATH=/dev/scsi/host0/bus0/target0/lun3
if [ -e $USB6_PATH/part1 ]; then
   USB_PATH=$USB6_PATH
fi
if [ -e $USB5_PATH/part1 ]; then
   USB_PATH=$USB5_PATH
fi
if [ -e $USB4_PATH/part1 ]; then
   USB_PATH=$USB4_PATH
fi
if [ -e $USB3_PATH/part1 ]; then
   USB_PATH=$USB3_PATH
fi
if [ -e $USB2_PATH/part1 ]; then
   USB_PATH=$USB2_PATH
fi
if [ -e $USB1_PATH/part1 -a ! -e $USB1_PATH/cd ]; then
   USB_PATH=$USB3_PATH
fi
if [ -e $USB0_PATH/part1 ]; then
   USB_PATH=$USB0_PATH
fi

swapoff -a > /dev/null 2>&1
echo "Stopping enigma2 To Make Sure That Harddisk Is Free"
init 4
 
killall -9 enigma2 > /dev/null 2>&1

umount /media/hdd/movie > /dev/null 2>&1
umount /media/hdd > /dev/null 2>&1
umount /media/usb/ba > /dev/null 2>&1
umount /media/usb > /dev/null 2>&1
mkdir -p /media/usb/usr/lib/ipkg > /dev/null 2>&1

if [ `mount | grep /media/hdd | wc -l` -gt 0 ]; then
   echo "Harddisk Still Mounted"
   exit 1
fi
if [ `mount | grep /media/usb | wc -l` -gt 0 ]; then
   echo "USB Stick Still Mounted"
   exit 1
fi
cp /etc/fstab $MYTMP0
grep -v /media/usb $MYTMP0 > $MYTMP1
grep -v /media/hdd $MYTMP1 > $MYTMP2
echo "$USB_PATH/part1 /media/hdd auto defaults            0 0" >> $MYTMP2
echo "$HD_PATH/part1 /media/hdd/movie auto  defaults     0 0" >> $MYTMP2
cp $MYTMP2 /etc/fstab
mount /media/hdd > /dev/null 2>&1
if [ `mount | grep /media/hdd | wc -l` -lt 1 ]; then
   echo "USB Stick Not Mounted , Reboot To Get Back To Normal Mount Situation"
   cp $MYTMP0 /etc/fstab
   exit 1
fi
mkdir -p /media/hdd/movie > /dev/null 2>&1
mount /media/hdd/movie > /dev/null 2>&1
if [ `mount | grep /media/hdd/movie | wc -l` -lt 1 ]; then
   echo "Harddisk Not Mounted , Reboot To Get Back To Normal Mount Situation"
   cp $MYTMP0 /etc/fstab
   exit 1
fi
if [ -f /media/hdd/ba.sh ]; then
   echo "Migrating Barry Allen"
   ln -snf /media/hdd /media/ba > /dev/null 2>&1

   IMAGES=`ls -1 /media/ba/ba`
   for IMAGE in $IMAGES; do
   if [ -d /media/ba/ba/$IMAGE/delta ]; then
      DELTA="delta"
   else
      DELTA=""
   fi

   if [ -f /media/ba/ba/$IMAGE/$DELTA/etc/fstab ]; then
      grep -v /media/usb /media/ba/ba/$IMAGE/$DELTA/etc/fstab > $MYTMP1
      grep -v /media/hdd $MYTMP1 > $MYTMP2
      echo "$USB_PATH/part1 /media/hdd auto defaults            0 0" >> $MYTMP2
      echo "$HD_PATH/part1 /media/hdd/movie auto  defaults     0 0" >> $MYTMP2
      cp $MYTMP2 /media/ba/ba/$IMAGE/$DELTA/etc/fstab
   fi
   ln -snf /media/hdd /media/ba/ba/$IMAGE/$DELTA/media/ba > /dev/null 2>&1

   if [ ! -f /media/ba/ba/$IMAGE/$DELTA/usr/bin/enigma2.sh ]; then
      if [ -f /media/ba/ba/$IMAGE/squashfs ]; then
         mount -o loop /media/ba/ba/$IMAGE/squashfs  /media/ba/ba/$IMAGE/boot/mnt/squashfs > /dev/null 2>&1
         if [ -f /media/ba/ba/$IMAGE/boot/mnt/squashfs/usr/bin/enigma2.sh ]; then
            cp /media/ba/ba/$IMAGE/boot/mnt/squashfs/usr/bin/enigma2.sh /media/ba/ba/$IMAGE/$DELTA/usr/bin/enigma2.sh > /dev/null 2>&1
         fi
         umount /media/ba/ba/$IMAGE/boot/mnt/squashfs > /dev/null 2>&1
      fi
   fi
   if [ -f /media/ba/ba/$IMAGE/$DELTA/usr/bin/enigma2.sh ]; then
      grep -v "#!/bin/sh" /media/ba/ba/$IMAGE/$DELTA/usr/bin/enigma2.sh > $MYTMP1
      echo "#!/bin/sh" > $MYTMP2
      echo "mount /media/hdd > /dev/null 2>&1" >> $MYTMP2
      echo "mount /media/hdd/movie > /dev/null 2>&1" >> $MYTMP2
      cat $MYTMP1 >> $MYTMP2
      cp $MYTMP2 /media/ba/ba/$IMAGE/$DELTA/usr/bin/enigma2.sh 
   fi

   done
fi
echo "Starting enigma2"
init 3
exit 0
